/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 212
#ifdef HAVE_CONFIG_H
#line 212
# include <config.h>
#line 212
#endif
#line 212
#include <sys/types.h>
#line 212

#line 212
#include "mailfromd.h"
#line 212
#include "prog.h"
#line 212
#include "builtin.h"
#line 212

#line 212

#line 765 "../../src/builtin/snarf.m4"

#line 1 "curhdr.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

struct current_header {
	mu_header_t hdr;
};

static void *
alloc_header()
{
	return xzalloc(sizeof(struct current_header));
}

static void
destroy_header(void *data)
{
	struct current_header *chdr = data;
	mu_header_destroy(&chdr->hdr);
	free(chdr);
}

static void
free_header(void *data)
{
	struct current_header *chdr = data;
	mu_header_destroy(&chdr->hdr);
}


#line 44

#line 44
static int HEADER_id;
#line 44 "curhdr.bi"


static mu_header_t
get_current_header(eval_environ_t env, mu_stream_t mstr)
{
	struct current_header *chdr = env_get_builtin_priv(env,HEADER_id);
	if (!chdr->hdr) {
		mu_header_t hdr;
		char *text;
		int rc;
		mu_off_t size;
		size_t total;
		size_t start;
		
		rc = mu_stream_size(mstr, &size);
			if (!(rc == 0))
#line 59
		(
#line 59
	env_throw_bi(env, mfe_failure, NULL, "mu_stream_size: %s",mu_strerror (rc))
#line 59
)
#line 62
;
		text = malloc(size + 1);
			if (!(text != NULL))
#line 64
		(
#line 64
	env_throw_bi(env, mfe_failure, NULL, _("not enough memory"))
#line 64
)
#line 66
;
		rc = mu_stream_seek(mstr, 0, SEEK_SET, NULL);
			if (!(rc == 0))
#line 68
		(
#line 68
	env_throw_bi(env, mfe_failure, NULL, "mu_stream_seek: %s",mu_strerror(rc))
#line 68
)
#line 71
;
		
		/* FIXME: Use "header" filter instead of this loop */
		for (total = 0; total < size;) {
			size_t nrd;
			
			rc = mu_stream_read(mstr, text + total,
					    size - total, &nrd);
			if (rc || nrd == 0)
				break;
			total += nrd;
		}
		text[total] = 0;

               /* FIXME: Reposition the stream at its end.
		  This call may happen in the middle of capturing
		  so I have to make sure to not disturb the capturing
		  process.

		  The same effect could have been achieved by using
		  streamref, but this approach speeds up things a
		  bit.
	       */
		env_reposition(env);
		
		if (memcmp (text, "From ", 5) == 0)
			start = strcspn (text, "\n") + 1;
		else
			start = 0;
		rc = mu_header_create(&hdr, text + start, total - start);
		free(text);
			if (!(rc == 0))
#line 102
		(
#line 102
	env_throw_bi(env, mfe_failure, NULL, "mu_header_create: %s",mu_strerror (rc))
#line 102
)
#line 105
;
		chdr->hdr = hdr;
	}
	return chdr->hdr;
}
		
/* number current_header_count([string name]) */




void
#line 116
bi_current_header_count(eval_environ_t env)
#line 116

#line 116

#line 116 "curhdr.bi"
{
#line 116
	  mu_stream_t mstr;
#line 116

#line 116
	
#line 116

#line 116
long __bi_argcnt;
#line 116
char *  name;
#line 116
        
#line 116
get_string_arg(env, 1, &name);
#line 116
        
#line 116
get_numeric_arg(env, 0, &__bi_argcnt);
#line 116
        adjust_stack(env, __bi_argcnt + 1);
#line 116

#line 116
{
#line 116
	  int rc = env_get_stream(env,&mstr);
#line 116
	  	if (!(rc == 0))
#line 116
		(
#line 116

#line 116
	mu_stream_unref(mstr),
#line 116
	env_throw_bi(env, mfe_failure, "current_header_count", "cannot obtain capture stream reference: %s",mu_strerror(rc))
#line 116
)
#line 116
;
#line 116
	}
#line 116
	if (builtin_module_trace(BUILTIN_IDX_curhdr))
#line 116
		prog_trace(env, "current_header_count %s",((__bi_argcnt > 0) ? name : ""));;
#line 116

{
	mu_header_t hdr = get_current_header(env, mstr);
	size_t total;
	size_t count;
	int rc = mu_header_get_field_count(hdr, &total);
	
		if (!(rc == 0))
#line 123
		(
#line 123

#line 123
	mu_stream_unref(mstr),
#line 123
	env_throw_bi(env, mfe_failure, "current_header_count", "mu_header_get_field_count: %s",mu_strerror(rc))
#line 123
)
#line 126
;
	if ((__bi_argcnt > 0)) {
		size_t i;
		count = 0;
		for (i = 1; i <= total; i++) {
			const char *sptr;
			if (mu_header_sget_field_name(hdr, i, &sptr) == 0
			    && strcasecmp(sptr, name) == 0)
				count++;
		}
	} else
		count = total;
	
#line 138
do {
#line 138
  push(env, (STKVAL) (count));
#line 138
  goto endlab;
#line 138
} while (0);
}
endlab:
#line 140

#line 140
	mu_stream_unref(mstr);
#line 140
        env_function_cleanup_flush(env, NULL);
#line 140
	return;
#line 140
}

/* string current_header_nth_name(number index) */




void
#line 147
bi_current_header_nth_name(eval_environ_t env)
#line 147

#line 147

#line 147 "curhdr.bi"
{
#line 147
	  mu_stream_t mstr;
#line 147

#line 147
	
#line 147

#line 147

#line 147
long  index;
#line 147
        
#line 147
get_numeric_arg(env, 0, &index);
#line 147
        
#line 147

#line 147
        adjust_stack(env, 1);
#line 147

#line 147
{
#line 147
	  int rc = env_get_stream(env,&mstr);
#line 147
	  	if (!(rc == 0))
#line 147
		(
#line 147

#line 147
	mu_stream_unref(mstr),
#line 147
	env_throw_bi(env, mfe_failure, "current_header_nth_name", "cannot obtain capture stream reference: %s",mu_strerror(rc))
#line 147
)
#line 147
;
#line 147
	}
#line 147
	if (builtin_module_trace(BUILTIN_IDX_curhdr))
#line 147
		prog_trace(env, "current_header_nth_name %lu",index);;
#line 147

{
	mu_header_t hdr = get_current_header(env, mstr);
	const char *sptr;
	int rc = mu_header_sget_field_name(hdr, index, &sptr);

	if (rc == MU_ERR_NOENT)
		(
#line 154

#line 154
	mu_stream_unref(mstr),
#line 154
	env_throw_bi(env, mfe_not_found, "current_header_nth_name", _("requested item (#%ld) not found"),index)
#line 154
);
#line 157
	else if (rc != 0)
		(
#line 158

#line 158
	mu_stream_unref(mstr),
#line 158
	env_throw_bi(env, mfe_failure, "current_header_nth_name", "mu_header_sget_field_name: %s",mu_strerror(rc))
#line 158
);
#line 161
	do {pushs(env, sptr);
#line 161
goto endlab;
#line 161
} while (0);
}
endlab:
#line 163

#line 163
	mu_stream_unref(mstr);
#line 163
        env_function_cleanup_flush(env, NULL);
#line 163
	return;
#line 163
}

/* string current_header_nth_value(number index) */




void
#line 170
bi_current_header_nth_value(eval_environ_t env)
#line 170

#line 170

#line 170 "curhdr.bi"
{
#line 170
	  mu_stream_t mstr;
#line 170

#line 170
	
#line 170

#line 170

#line 170
long  index;
#line 170
        
#line 170
get_numeric_arg(env, 0, &index);
#line 170
        
#line 170

#line 170
        adjust_stack(env, 1);
#line 170

#line 170
{
#line 170
	  int rc = env_get_stream(env,&mstr);
#line 170
	  	if (!(rc == 0))
#line 170
		(
#line 170

#line 170
	mu_stream_unref(mstr),
#line 170
	env_throw_bi(env, mfe_failure, "current_header_nth_value", "cannot obtain capture stream reference: %s",mu_strerror(rc))
#line 170
)
#line 170
;
#line 170
	}
#line 170
	if (builtin_module_trace(BUILTIN_IDX_curhdr))
#line 170
		prog_trace(env, "current_header_nth_value %lu",index);;
#line 170

{
	mu_header_t hdr = get_current_header(env, mstr);
	const char *sptr;
	int rc = mu_header_sget_field_value(hdr, index, &sptr);

	if (rc == MU_ERR_NOENT)
		(
#line 177

#line 177
	mu_stream_unref(mstr),
#line 177
	env_throw_bi(env, mfe_not_found, "current_header_nth_value", _("requested item (#%ld) not found"),index)
#line 177
);
#line 180
	else if (rc != 0)
		(
#line 181

#line 181
	mu_stream_unref(mstr),
#line 181
	env_throw_bi(env, mfe_failure, "current_header_nth_value", "mu_header_sget_field_name: %s",mu_strerror(rc))
#line 181
);
#line 184
	do {pushs(env, sptr);
#line 184
goto endlab;
#line 184
} while (0);
}
endlab:
#line 186

#line 186
	mu_stream_unref(mstr);
#line 186
        env_function_cleanup_flush(env, NULL);
#line 186
	return;
#line 186
}

/* string current_header(string name[, number index]) */

	


void
#line 193
bi_current_header(eval_environ_t env)
#line 193

#line 193

#line 193 "curhdr.bi"
{
#line 193
	  mu_stream_t mstr;
#line 193

#line 193
	
#line 193

#line 193
long __bi_argcnt;
#line 193
char * MFL_DATASEG name;
#line 193
        long  index;
#line 193
        
#line 193
get_string_arg(env, 1, &name);
#line 193
        get_numeric_arg(env, 2, &index);
#line 193
        
#line 193
get_numeric_arg(env, 0, &__bi_argcnt);
#line 193
        adjust_stack(env, __bi_argcnt + 1);
#line 193

#line 193
{
#line 193
	  int rc = env_get_stream(env,&mstr);
#line 193
	  	if (!(rc == 0))
#line 193
		(
#line 193

#line 193
	mu_stream_unref(mstr),
#line 193
	env_throw_bi(env, mfe_failure, "current_header", "cannot obtain capture stream reference: %s",mu_strerror(rc))
#line 193
)
#line 193
;
#line 193
	}
#line 193
	if (builtin_module_trace(BUILTIN_IDX_curhdr))
#line 193
		prog_trace(env, "current_header %s %lu",name, ((__bi_argcnt > 1) ? index : 0));;
#line 193

{
	mu_header_t hdr = get_current_header(env, mstr);
	const char *sptr;
	int rc = mu_header_sget_value_n(hdr, name, ((__bi_argcnt > 1) ? index : 1),
					&sptr);

	if (rc == MU_ERR_NOENT)
		(
#line 201

#line 201
	mu_stream_unref(mstr),
#line 201
	env_throw_bi(env, mfe_not_found, "current_header", _("requested item (%s,%ld) not found"),name,((__bi_argcnt > 1) ? index : 1))
#line 201
);
#line 204
	else if (rc != 0)
		(
#line 205

#line 205
	mu_stream_unref(mstr),
#line 205
	env_throw_bi(env, mfe_failure, "current_header", "mu_header_sget_field_name: %s",mu_strerror(rc))
#line 205
);
#line 208
	do {pushs(env, sptr);
#line 208
goto endlab;
#line 208
} while (0);
}
endlab:
#line 210

#line 210
	mu_stream_unref(mstr);
#line 210
        env_function_cleanup_flush(env, NULL);
#line 210
	return;
#line 210
}


#line 212
void
#line 212
curhdr_init_builtin()
#line 212
{
#line 212
	
#line 212
	#line 44 "curhdr.bi"
HEADER_id = builtin_priv_register(alloc_header, destroy_header,
#line 44
free_header);
#line 116 "curhdr.bi"
va_builtin_install_ex("current_header_count", bi_current_header_count, STATMASK(smtp_state_eoh) | STATMASK(smtp_state_body) | STATMASK(smtp_state_eom), dtype_number, 1, 1, MFD_BUILTIN_CAPTURE|0, dtype_string);
#line 147 "curhdr.bi"
va_builtin_install_ex("current_header_nth_name", bi_current_header_nth_name, STATMASK(smtp_state_eoh) | STATMASK(smtp_state_body) | STATMASK(smtp_state_eom), dtype_string, 1, 0, MFD_BUILTIN_CAPTURE|0, dtype_number);
#line 170 "curhdr.bi"
va_builtin_install_ex("current_header_nth_value", bi_current_header_nth_value, STATMASK(smtp_state_eoh) | STATMASK(smtp_state_body) | STATMASK(smtp_state_eom), dtype_string, 1, 0, MFD_BUILTIN_CAPTURE|0, dtype_number);
#line 193 "curhdr.bi"
va_builtin_install_ex("current_header", bi_current_header, STATMASK(smtp_state_eoh) | STATMASK(smtp_state_body) | STATMASK(smtp_state_eom), dtype_string, 2, 1, MFD_BUILTIN_CAPTURE|0, dtype_string, dtype_number);

#line 212 "curhdr.bi"
	
#line 212
}
#line 212 "curhdr.bi"

#line 212

#line 759 "../../src/builtin/snarf.m4"

#line 759

